/******************************************************************************
*    Un interupteur telemétrique avec le module Tof10120 ! avec affichage     *
*    de la distance sur LCD 2x16 caractères  Si vous approchez                *
*    du capteur la sortie est activée et si vous vous en eloignez la sortie   *
*    passe à zero logique ! La distance est fixée à 500 mm en approche et     *
*    500 mm en éloignement pour l'extinction ou la distance maximale          *
***************************************************************************** */
 
 
#include <Wire.h>
#include <LiquidCrystal_I2C.h> // Interface I2C <=> LCD
#include <SimpleTimer.h>
 
SimpleTimer timer;
 
unsigned short lenth_val = 0;
unsigned char i2c_rx_buf[16];  //Reserve un buffer de deux octets sur le bus I2C
 
int x_mm; // distance en milimetres
int reLay = 13;  // Afectation de la sortie relais
int oldPos = 2000 ;  // Initialisation de l'ancienne valeur de la distance 
 
LiquidCrystal_I2C lcd(0x27,16,2);  // Donne les paramètre du LCD sur le bus I2C

 
void setup() {
    pinMode(reLay, OUTPUT);  //DDR de la sortie relais
 digitalWrite(reLay, LOW); // au niveau bas
  Wire.begin(); // initialisationde la com
   lcd.init();                      // initialise le lcd 
 lcd.backlight();
timer.setInterval(500L, display_measurement);
}

 
void loop() {
  timer.run(); // Initialise le SimpleTimer
  x_mm = ReadDistance(); // Attribut les valeurs buffeurisée lors de la transmition I2C ....
}
 
  
void SensorRead(unsigned char addr,unsigned char* datbuf,unsigned char cnt) 
{
  unsigned short result=0;
  // étape 1 : demander au capteur de lire les échos
  Wire.beginTransmission(82); // transmettre au composant #82 (0x52)
  //l'adresse indiquée dans la fiche technique est 164 (0xa4) mais l'adressage i2c utilise les 7 bits de poids fort donc c'est 82
  Wire.write(byte(addr));      // définit l'adresse de données de distance (addr)
  Wire.endTransmission();      // Fin de transmission

  // étape 2 : attendez que les lectures se produisent
  delay(1); // la fiche technique suggère au moins 30µS
  
  // étape 3 : demande de la lecture du capteur
  Wire.requestFrom(82, cnt);    //demande des octets contenus dans le composant esclave #82 (0x52)
  
  // étape 4 : reçoit la lecture du capteur
  if (cnt <= Wire.available()) { // si deux octets ont été reçus, on reçoit l'octet de poids fort (écrase la lecture précédente)puis l'octet de poids faible
    *datbuf++ = Wire.read();
    *datbuf++ = Wire.read(); 
  }
}
 
int ReadDistance(){ // Lecture de la distance et mémorisation des octets reçus dans les deux buffers
    SensorRead(0x00,i2c_rx_buf,2);
    lenth_val=i2c_rx_buf[0];
    lenth_val=lenth_val<<8;
    lenth_val|=i2c_rx_buf[1];
    delay(300); 
    return lenth_val;
}
 
 
void display_measurement()
{
//lcd.clear();
lcd.setCursor(3,0);
lcd.print("Distance"); 
lcd.setCursor(1, 1); 
lcd.print(x_mm);
lcd.print(" milimetres    ");
if  ( x_mm < (oldPos - 500)) { //Si la nouvelle mesure est > de 50 cm à l'ancienne, on allume la charge
  digitalWrite(reLay, HIGH);
  oldPos = x_mm ; // mémorisation de la nouvelle valeur
}

if (( x_mm > (oldPos + 500)) or (x_mm > 1800)) { //Si la nouvelle mesure est < de 50 cm à l'ancienne,ou >1,80m on eteind la charge
  digitalWrite(reLay, LOW);
  oldPos = x_mm ;  // mémorisation de la nouvelle valeur 
}

}

}
